const defaultTheme = require("tailwindcss/defaultTheme");
import franken from "franken-ui/shadcn-ui/preset-quick";

/** @type {import('tailwindcss').Config} */
module.exports = {
  presets: [
    franken({
      customPalette: {
        ".uk-theme-wirm": {
          "--background": "214 52% 100%",
          "--foreground": "214 61% 1%",
          "--muted": "214 6% 92%",
          "--muted-foreground": "214 2% 27%",
          "--popover": "214 52% 100%",
          "--popover-foreground": "214 61% 1%",
          "--card": "214 52% 100%",
          "--card-foreground": "214 61% 1%",
          "--border": "214 15% 90%",
          "--input": "214 15% 90%",
          "--primary": "214 100% 34%",
          "--primary-foreground": "214 100% 94%",
          "--secondary": "214 5% 80%",
          "--secondary-foreground": "214 5% 20%",
          "--accent": "214 5% 80%",
          "--accent-foreground": "214 5% 20%",
          "--destructive": "13 86% 34%",
          "--destructive-foreground": "13 86% 94%",
          "--ring": "214 100% 34%",
          "--chart-1": "214 100% 34%",
          "--chart-2": "214 5% 80%",
          "--chart-3": "214 5% 80%",
          "--chart-4": "214 5% 83%",
          "--chart-5": "214 103% 34%",
          "--radius": "0.5rem",
        },
        ".dark.uk-theme-wirm": {
          "--background": "214 36% 1%",
          "--foreground": "214 37% 99%",
          "--muted": "214 6% 8%",
          "--muted-foreground": "214 2% 73%",
          "--popover": "214 36% 1%",
          "--popover-foreground": "214 37% 99%",
          "--card": "214 36% 1%",
          "--card-foreground": "214 37% 99%",
          "--border": "214 15% 14%",
          "--input": "214 15% 14%",
          "--primary": "214 100% 34%",
          "--primary-foreground": "214 100% 94%",
          "--secondary": "214 13% 16%",
          "--secondary-foreground": "214 13% 76%",
          "--accent": "214 13% 16%",
          "--accent-foreground": "214 13% 76%",
          "--destructive": "13 86% 45%",
          "--destructive-foreground": "0 0% 100%",
          "--ring": "214 100% 34%",
          "--chart-1": "214 100% 34%",
          "--chart-2": "214 13% 16%",
          "--chart-3": "214 13% 16%",
          "--chart-4": "214 13% 19%",
          "--chart-5": "214 103% 34%",
        },
      },
    }),
  ],
  content: [],
  safelist: [
    {
      pattern: /^uk-/,
    },
    "ProseMirror",
    "ProseMirror-focused",
    "tiptap",
    "mr-2",
    "mt-2",
    "opacity-50",
  ],
  theme: {
    extend: {
      fontFamily: {
        sans: ["Geist", ...defaultTheme.fontFamily.sans],
        mono: ['"Geist Mono"', ...defaultTheme.fontFamily.mono],
      },
    },
  },
  plugins: [],
};
